// This file was generated by Dashcode from Apple Computer, Inc.
// You may edit this file to customize your Dashboard widget.

var entries;
var currentEntry;

var DFFeedTypeHTML = 0;
var DFFeedTypeImage = 1;

// Namespace URLs
var NS_DC = "http://purl.org/dc/elements/1.1/";
var NS_CONTENT = "http://purl.org/rss/1.0/modules/content/";

function load()
{
	setupParts();
	setHandlers();
	hideElement("backButton");
	hideElement("forwardButton");
	document.addEventListener("keypress", keyPressed, true);
	
	entries = new Array();

	clearContent();
	refreshFeed();	
}

function remove()
{
	// your widget has just been removed from the layer
	// remove any preferences as needed
	// widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

function hide()
{
	// your widget has just been hidden stop any timers to
	// prevent cpu usage
}

function show()
{
	// your widget has just been shown.  restart any timers
	// and adjust your interface as needed
}

function showBack(event)
{
	// your widget needs to show the back


	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
		backLinks();

	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

function showFront(event)
{
	// your widget needs to show the front

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");

	front.style.display="block";
	back.style.display="none";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

function backLinks()
{
	var back = document.getElementById("back");
	if(back){
		var linkDiv = document.createElement('div');
		linkDiv.setAttribute('id', 'tjstephens');
		linkDiv.innerHTML = 'tjstephens';
		linkDiv.setAttribute('myLink', 'http://www.tjstephens.com');
		linkDiv.setAttribute('onclick', 'clickOnLink(event, this);');
		//fixLinks(linkDiv);
		back.appendChild(linkDiv);
		
		linkDiv = document.createElement('div');
		linkDiv.setAttribute('id', 'infoOwner');
		linkDiv.innerHTML = getLocalizedString('Surf reports from http://www.cornwalls.co.uk/surfing/');
		linkDiv.setAttribute('myLink', 'http://www.cornwalls.co.uk/surfing/');
		linkDiv.setAttribute('onclick', 'clickOnLink(event, this);');
		//fixLinks(linkDiv);
		back.appendChild(linkDiv);
		}

}
/*
 getFirstElementByTagName() is a convenience method to return just the first element of getElementsByTagName()'s results, or null if there are none
*/
function getFirstElementByTagName(node, tag_name, namespace) {
	var elements;

	if (!namespace) {
		elements = node.getElementsByTagName(tag_name);
	}
	else {
		elements = node.getElementsByTagNameNS(namespace, tag_name);
	}

	if (elements.length) {
		return elements[0];
	}
	else {
		return null;
	}
}

function parseISODate(dateToParse){
	var returnDate = new Date();
	if(dateToParse && dateToParse.length>1 && dateToParse.match(/^\d\d\d\d-\d\d-\d\d/)){
        // separate date and time
        var dateTime=dateToParse.split("T");
        // set the date
        var dateArray = dateTime[0].split("-");
        if(dateArray[1]) returnDate.setMonth(dateArray[1]-1);
        if(dateArray[2]) returnDate.setDate(dateArray[2]);
        if(dateArray[0]) returnDate.setYear(dateArray[0]);
        // split time and offset
        var timeArray = null;
        if(dateTime[1]) timeArray=dateTime[1].match(/(\d\d):(\d\d):(\d\d)(?:\.\d+)?(?:([+-])(\d\d):(\d\d))?/);
        if(timeArray){
            // set the time
            if(timeArray[1]) returnDate.setHours(timeArray[1]);
            if(timeArray[2]) returnDate.setMinutes(timeArray[2]);
            if(timeArray[3]) returnDate.setSeconds(timeArray[3]);
            // add the offset
            if(timeArray[4] && timeArray[5]){
                var time = returnDate.getTime() - returnDate.getTimezoneOffset() * 60000;
                if(timeArray[4]=="+")
                    time -= timeArray[5] * 3600000;
                else
                    time += timeArray[5] * 3600000;
                returnDate.setTime(time);
            }
		}
	}
	return returnDate;
}

function setHandlers()
{
	var backOver = new Image();
	backOver.src = "Images/backButton_over.png";
	var backDown = new Image();
	backDown.src = "Images/backButton_down.png";
	var forwardOver = new Image();
	forwardOver.src = "Images/forwardButton_over.png";
	var forwardDown = new Image();
	forwardDown.src = "Images/forwardButton_down.png";

	var backButton = document.getElementById("backButton");
	if (backButton) {
		addHilightListeners(backButton, backOver, backDown);
	}

	var forwardButton = document.getElementById("forwardButton");
	if (forwardButton) {
		addHilightListeners(forwardButton, forwardOver, forwardDown);
	}
}

function addHilightListeners(element, overImage, downImage)
{
	var offImage = new Image();
	offImage.src = element.src;

	element.addEventListener("mouseover", function () { swapImage(element, overImage) }, true);
	element.addEventListener("mousedown", function () { swapImage(element, downImage) }, true);
	element.addEventListener("mouseup", function () { swapImage(element, overImage) }, true);
	element.addEventListener("mouseout", function () { swapImage(element, offImage) }, true);
}

function swapImage(element, image)
{
	element.src = image.src;
}

function clearContent()
{
	var content = document.getElementById("content");
	if (content) {
		while (content.firstChild) {
			content.removeChild(content.firstChild);
		}
	}
}

function setDateText(date)
{
	var dateText = document.getElementById("dateText");
	if (dateText) {
		if (date != null) {
			if (typeof(date) == "string") {
				dateText.innerText = date;
			}
			else {
				var dateStr = date.toLocaleDateString();
				dateText.innerText = dateStr;
			}
		}
		else {
			dateText.innerText = getLocalizedString("Daily Feed");
		}
	}
}

function setHTMLContent(title, description, date, link)
{
	var content = document.getElementById("content");
	if (content) {
		clearContent();

		if (title != null) {
			var titleDiv = document.createElement("div");
			titleDiv.setAttribute("id", "entryTitle");
			titleDiv.innerHTML = title;
			fixLinks(titleDiv);
			content.appendChild(titleDiv);
		}

		if (description != null) {
			var descDiv = document.createElement("div");
			descDiv.setAttribute("id", "entryDescription");
			descDiv.innerHTML = description;
			fixLinks(descDiv);
			content.appendChild(descDiv);
		}
		
		if (link != null) {
			var linkDiv = document.createElement('div');
			linkDiv.setAttribute('id', 'entryLink');
			linkDiv.innerHTML = 'more &raquo;';
			linkDiv.setAttribute('myLink', link);
			linkDiv.setAttribute('onclick', 'clickOnLink(event, this);');
			//fixLinks(linkDiv);
			content.appendChild(linkDiv);
		}
		
		setDateText(date);
	}
	
}

function setImageContent(title, image, date)
{
	var content = document.getElementById("content");
	if (content) {
		clearContent();

		if (image != null) {
			var imgElement = document.createElement("img");
			imgElement.setAttribute("src", image.src);

			var box_style = document.defaultView.getComputedStyle(content, '');
			var box_height = parseInt(box_style.height);
			var box_width  = parseInt(box_style.width);
			var box_aspect = box_height / box_width;
			var	img_aspect = image.height / image.width;
	
			var w = box_width;
			var h = box_height;
			var	x = 0;
			var y = 0;
	
			if (img_aspect > box_aspect) {
				// Tall
				var ratio = box_height / image.height;
				w = Math.round(image.width * ratio);
				h = Math.round(image.height * ratio);
				x = Math.floor((box_width - w) / 2);
			}
			else if (img_aspect < box_aspect) {
				// Wide
				var ratio = box_width / image.width;
				w = Math.round(image.width * ratio);
				h = Math.round(image.height * ratio);
				y = Math.floor((box_height - h) / 2);
			}

			imgElement.setAttribute("width", w);
			imgElement.setAttribute("height", h);

			imgElement.style.width = w + "px";
			imgElement.style.height = h + "px";
			imgElement.style.marginTop = y + "px";
			imgElement.style.marginLeft = x + "px";

			content.appendChild(imgElement);
		}
		
		setDateText(date);
	}
}

function showEntry(entryNumber)
{
	currentEntry = entryNumber;
	
	if (entries[entryNumber]) {
		var entry = entries[entryNumber];
		if (entry.description != null) {
			setHTMLContent(entry.title, entry.description, entry.date, entry.link);
		}
		else if (entry.image != null) {
			setImageContent(entry.title, entry.image, entry.date, entry.link);
		}
		
		if (entryNumber > 0) {
			showElement("backButton");
		}
		else {
			hideElement("backButton");
		}
		
		if (entryNumber < entries.length - 1) {
			showElement("forwardButton");
		}
		else {
			hideElement("forwardButton");
		}
	}
}

function showElement(elementId)
{
	var element = document.getElementById(elementId);
	if (element) {
		element.style.display = "block";
	}
}

function hideElement(elementId)
{
	var element = document.getElementById(elementId);
	if (element) {
		element.style.display = "none";
	}
}

// Display error message in the content box
function showError(errorHTML)
{
	setHTMLContent(getLocalizedString("Error"), errorHTML);
	setDateText(getLocalizedString("Daily Feed"));
	hideElement("forwardButton");
	hideElement("backButton");
}

// Remove all the stored feed entries
function clearEntries()
{
	entries.length = 0;
}

// Make the HTTP request to fetch a feed and send the results to the parser
function refreshFeed()
{
	var url = attributes.feedURL;
	if (url && url.length) {
		url = url.replace(/^feed:\/\//, "");
		if (url.substring(0,7).toLowerCase() != "http://") {
			url = "http://" + url;
		}
	}
	else {
		showError(getLocalizedString("No feed URL supplied."));
		return;
	}

	setDateText(getLocalizedString("Loading") + "...");

	var xml_request = new XMLHttpRequest();
	xml_request.overrideMimeType("text/xml");
	xml_request.open("GET", url, true);
	
	xml_request.onreadystatechange = function () {
		if (xml_request.readyState == 4) {
			parseResponse(xml_request.responseXML);
		}
	};
	
	xml_request.send(null);
}

function parseResponse(doc)
{
	clearEntries();

	try {
		// Try to figure out what we got back
		if (doc && doc.documentElement) {
			if (doc.documentElement.nodeName == "feed") {
				// Atom
				parseAtomFeed(doc);
			}
			else {
				// Use the RSS parser
				parseRSSFeed(doc);
			}
		}
		else {
			throw new Error(getLocalizedString("Failed to load a valid feed."));
		}
		
		if (entries && entries.length) {
			showEntryWhenLoaded(entries.length - 1);
		}
		else {
			throw new Error("Feed contains no entries.");
		}
	}
	catch (ex) {
		showError(ex);
	}
}

function showEntryWhenLoaded(entryNumber)
{
	var loading = 0;
	for (i = 0; i < entries.length; i++) {
		if (entries[i].image && !entries[i].image.complete) {
			loading++;
		}
	}

	if (loading) {
		setTimeout(function () { showEntryWhenLoaded(entryNumber) }, 250);
	}
	else {
		showEntry(entryNumber);
	}
	setBeachList();

}

function allData(node)
{
	var data = "";
	node = node.firstChild;
	if(node){
		if (node.data) data += node.data;
		while (node = node.nextSibling) {
			if (node.data) data += node.data;
		}
	}

	return data;
}

// Find the first image in a block of HTML
function getFirstImage(htmlData)
{
	// Create a phony DIV to hold the HTML so we can use DOM methods on it
	var div = document.createElement("div");
	div.innerHTML = htmlData;
	
	var imgElement = getFirstElementByTagName(div, "img");
	if (imgElement) {
		var image = new Image();
		image.src = imgElement.src;
		
		return image;
	}
}

//---------------------------------------------------------------------------------------------
//	fixLinks()
//	Correct hyperlinks in a document fragment to use the openURL function.
//---------------------------------------------------------------------------------------------
function fixLinks(htmlFragment)
{
	// Collect all the links
	var links = htmlFragment.getElementsByTagName("a");
	for (var i = 0; i < links.length; i++) {
		var aNode = links[i];
		// Send them to our clickOnLink function
		aNode.onclick = clickOnLink;
	}
}

//---------------------------------------------------------------------------------------------
//	clickOnLink()
//	Open in the browser instead of in the widget.
//---------------------------------------------------------------------------------------------
function clickOnLink(event, div)
{
	if (window.widget) {
		widget.openURL(div.myLink);
	} else document.location = div.myLink;
}

function parseRSSFeed(doc)
{
	var items = doc.getElementsByTagName("item");
	for (var i = 0; i < items.length; i++) {
		var thisItem = items[i];

		var title = getLocalizedString("Untitled");
		var titleElt = getFirstElementByTagName(thisItem, "title");
		if (titleElt && titleElt.firstChild) {
			title = allData(titleElt);
		}

		var description;
		var descElt = getFirstElementByTagName(thisItem, "encoded", NS_CONTENT);
		if (!descElt) {
			descElt = getFirstElementByTagName(thisItem, "description");
		}
		if (descElt && descElt.firstChild) {
			description = allData(descElt);
		}

		var pubDate = getFirstElementByTagName(thisItem, "pubDate");
		// If there's a pubDate element, use it
		if (pubDate) {
			pubDate = new Date(Date.parse(allData(pubDate)));
		}
		// If not, maybe they're using the Dublin Core date element
		if (pubDate == null) {
			pubDate = getFirstElementByTagName(thisItem, "date", NS_DC);
			if (pubDate) {
				var isoDate = allData(pubDate);
				pubDate = parseISODate(isoDate);
			}
		}
		
		//Add the link to the surf reports page --tjs
		var link = getLocalizedString("Link");
		var linkElt = getFirstElementByTagName(thisItem, "link");
		if (linkElt && linkElt.firstChild) {
			link = allData(linkElt);
		}

		if (+attributes.feedType == DFFeedTypeHTML) {
			// HTML feed
			if (description) {
				entries.unshift({ title: title, description: description, date: pubDate, link:link });
			}
		}
		else if (+attributes.feedType == DFFeedTypeImage) {
			// Photo feed
			var image = getFirstImage(description);
			if (image) {
				entries.unshift({ title: title, image: image, date: pubDate });
			}
		}
	}
}

function parseAtomFeed(doc)
{
	var feed = getFirstElementByTagName(doc, "feed");
	if (feed) {
		for (var thisItem = feed.firstChild; thisItem != null; thisItem = thisItem.nextSibling) {
			if (thisItem.nodeName == "entry") {
				var title = getLocalizedString("Untitled");
				var titleElt = getFirstElementByTagName(thisItem, "title");
				if (titleElt && titleElt.firstChild) {
					title = allData(titleElt);
				}
		
				var description;
				var descElt = getFirstElementByTagName(thisItem, "summary");
				if (descElt == null) { descElt = getFirstElementByTagName(thisItem, "content"); }
				if (descElt && descElt.firstChild) {
					var contentType = descElt.getAttribute("type");
					if(contentType && (contentType.indexOf("xhtml")>-1 || contentType.indexOf("xml")>-1)){
						var xmlSerializer = new XMLSerializer();
						description = "";
						for(var f=0; f<descElt.childNodes.length; f++)
							description += xmlSerializer.serializeToString(descElt.childNodes[f]);
					}
					else{
						description = allData(descElt);
					}
				}

				var pubDate;
				var pubDateElt = getFirstElementByTagName(thisItem, "updated");
				if (pubDateElt == null) { pubDateElt = getFirstElementByTagName(thisItem, "issued"); }
				if (pubDateElt == null) { pubDateElt = getFirstElementByTagName(thisItem, "modified"); }
				if (pubDateElt == null) { pubDateElt = getFirstElementByTagName(thisItem, "created"); }
				if (pubDateElt && pubDateElt.firstChild) {
					var isoDate = allData(pubDateElt);
					pubDate = parseISODate(isoDate);
				}

				if (+attributes.feedType == DFFeedTypeHTML) {
					// HTML feed
					if (description) {
						entries.unshift({ title: title, description: description, date: pubDate });
					}
				}
				else if (+attributes.feedType == DFFeedTypeImage) {
					// Photo feed
					var image = getFirstImage(description);
					if (image) {
						entries.unshift({ title: title, image: image, date: pubDate });
					}
				}
			}
		}
	}
	else {
		throw new Error(getLocalizedString("No <feed> element in Atom feed."));
	}
}

if (window.widget)
{
	widget.onremove = remove;
	widget.onhide = hide;
	widget.onshow = show;
}

function showPrevEntry(event)
{
	if (entries && entries.length) {
		if (--currentEntry < 0) {
			currentEntry = 0;
		}

		showEntry(currentEntry);
		setBeachList(currentEntry);
	}
}

function showNextEntry(event)
{
	if (entries && entries.length && currentEntry < entries.length) {
		if (++currentEntry >= entries.length) {
			currentEntry = entries.length - 1;
		}

		showEntry(currentEntry);
		setBeachList(currentEntry);
	}
}

function keyPressed(event)
{
	switch (event.keyIdentifier) {
		case "Left":
			showPrevEntry();
			break;
		case "Right":
			showNextEntry();
			break;
		default:
			return;
	}
        
	event.stopPropagation();
	event.preventDefault();
}

function setBeachList(currentValue)
{
	var entry;
	var beachList = document.getElementById('beachList');
	if(currentValue == null){	
		beachList.innerHTML='';
		for(entry = 0; entry < entries.length ; ++entry){
			beachList.innerHTML=beachList.innerHTML+'<option value="'+entry+'">'+entries[entry].title+'</option>';
		}
		if(window.widget)
		{
			beachList.selectedIndex=widget.preferenceForKey("selectedBeach");
			//var worldString = widget.preferenceForKey(makeKey("worldString"));
			showEntry(beachList.selectedIndex);
		}
	} else {
		beachList.selectedIndex=currentValue;
	}
	
}

function changeBeach(event)
{	
	var elem = document.getElementById('beachList');
	if(window.widget)
	{
		widget.setPreferenceForKey(elem.selectedIndex, "selectedBeach");	//save the new preference to disk
	}
	showEntry(elem.selectedIndex);

	
} 
